<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\SWITCHModel;
use App\Helpers\Part\SWITCHHelper;
use App\Forms\Part\SWITCHForm;
use App\Entities\Part\SWITCHEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\Equipment\ServerEntity;
use App\Entities\CommonEntity;
use App\DTOs\Part\SWITCHDTO;

class SWITCHService extends PartType3Service
{
    private $_form = null;
    private $_helper = null;
    public function __construct(SWITCHModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('SWITCH');
    }
    public function getDTOClass(): string
    {
        return SWITCHDTO::class;
    }
    public function createDTO(array $formDatas): SWITCHDTO
    {
        return new SWITCHDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return SWITCHEntity::class;
    }
    public function getFormService(): SWITCHForm
    {
        if ($this->_form === null) {
            $this->_form = new SWITCHForm();
            $this->_form->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): SWITCHHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new SWITCHHelper();
            $this->_helper->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): SWITCHEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('code ASC');
        parent::setOrderBy($field, $value);
    }

    //서버관련 작업
    //파트정보가져오기
    public function getPartEntityByServer(ServerEntity $serverEntity): SWITCHEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverEntity->getSwitchInfoUid());
        if (!$entity instanceof SWITCHEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverEntity->getSwitchInfoUid()}에 해당하는 IP정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function attachToServer(ServerEntity $serverEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::attachToServer($serverEntity, $formDatas);
        return $entity;
    }
    public function detachFromServer(ServerEntity $serverEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::detachFromServer($serverEntity, $formDatas);
        return $entity;
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): SWITCHEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof SWITCHEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 Switch정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function attachToServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::attachToServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
    public function detachFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): SWITCHEntity
    {
        /** @var SWITCHEntity $entity IDE에 entity type알려주기*/
        $entity = parent::detachFromServerPart($serverPartEntity, $formDatas);
        return $entity;
    }
}
